
#include <stdio.h>
#include <cmath>

template <class type>
  type max( type a, type b )
  {
    return a > b ? a : b;
  }

template <class type>
  type min( type a, type b )
  {
    return a < b ? a : b;
  }
template <class type>
  unsigned long long round_m( type a )
  {
    if ((unsigned long long)(a * 10) % 10 > 0)
      return (unsigned long long)a + 1;
    return (unsigned long long)a;
  }

void main( void )
{
  unsigned long long a, b, k;

  scanf("%llu %llu %llu", &a, &b, &k);
  unsigned long long min3 = round_m(std::pow(a, 1.0 / 3));
  unsigned long long max3 = (unsigned long long)(std::pow(b, 1.0 / 3));
  if (min3 == 0)
    min3 = 1;
  if (k == 0)
  {
    unsigned long long res = 0;
    for (unsigned long long y = max3; y >= min3; y--)
    {
      unsigned long long y3 = y * y * y;
      long double sq = std::sqrt(y3);
      unsigned long long sq_i = (unsigned long long)sq;
      if (sq == sq_i)
        res++;
    }
    printf("%llu\n", res);
    return;
  }
  // k != 0
}
